/* base on
 * http://www.smspower.org/forums/6783-OneMoreTimePaddleControlPlusPaddleDetectionRegionDetection
 * http://www.raphnet.net/electronique/sms_paddle/index_en.php
 */

int pinLEFT, pinRIGHT, pinUP, pinDOWN, pinTR, pinTH, pinAI;
int HighBits, LowBits;
long inputRAW, inputByte, Working;

void setup() {
       pinLEFT = 3;
       pinMode(pinLEFT, OUTPUT);
       pinRIGHT = 6;
       pinMode(pinRIGHT, OUTPUT);
       pinUP = 5;
       pinMode(pinUP, OUTPUT);
       pinDOWN =4;
       pinMode(pinDOWN, OUTPUT);
       pinTR = 9;
       pinMode(pinTR , OUTPUT);
       pinAI = 7;
       attachInterrupt(0, AskingForData, CHANGE);//it didn't work using Rising and Falling events
       pinTH = 2; //related with previous assignment to Interrupt 0
       
/* Connection diagram with Arduino NANO according to previous asignation
 * DB9 PIN 9 - white    - pinTR (data available confirming)
 * DB9 PIN 8 - black    - arduino GND 
 * DB9 PIN 7 - gray     - pinTH input from SMS => attached to Interrupt 0 (Arduino pin 2)
 * DB9 PIN 6 - blue     - button A (TL signal). The other side of button will be connected to GND
 * DB9 PIN 5 - green    - Arduino 5V
 * DB9 PIN 4 - red      - pinRIGHT
 * DB9 PIN 3 - orange   - pinLEFT
 * DB9 PIN 2 - yellow   - pinDOWN
 * DB9 PIN 1 - brown    - pinUP
 * potentiometer: one side to 5V, other side to GND and intermediate connection to pinAI (analog input)
 */
inputRAW = 0b0000;
inputByte = 0;

Working = 0;
HighBits = 0;
LowBits = 0;

}

void sendBits(int HalfByte){
      digitalWrite(pinUP, (HalfByte & 0x01));
      HalfByte = HalfByte >> 1;
      digitalWrite(pinRIGHT, (HalfByte & 0x01));
      HalfByte = HalfByte >> 1;
      digitalWrite(pinLEFT, (HalfByte & 0x01));
      HalfByte = HalfByte >> 1;
      digitalWrite(pinDOWN, (HalfByte & 0x01));
}

void loop() {
      inputRAW = long(analogRead(pinAI));
      if (!Working){
        //data convertion from 0-1023 to 8 bits (255)
        inputByte = (inputRAW * 255) /1023; //only one instruction to avoid interrupt during conversion
      }
}

void AskingForData() {
    if ( (digitalRead(pinTH) == 1) && (Working ==1) ){
      sendBits(HighBits);
      digitalWrite(pinTR, HIGH);
      Working = 0; //to do not refresh inputByte from potentiometer before sending the Low bits
      }
    else if (digitalRead(pinTH) == 0){
      HighBits = (inputByte >> 4);
      LowBits = (inputByte & 0x0F);
      digitalWrite(pinTR, LOW);
      sendBits(LowBits);
      Working = 1;
      }
}


